--VERSION 0.0.15
--DATE 11 09 2014

--RECENT CHANGES
--reworked buttons in roll frame to react to index and generally be a bit smarter, merged button roll functions into a single function

--TO DO
--FIX GUID
-- display rolls in the "roll recount" window 

local RLRFrame=CreateFrame("Frame") -- creating  a frame for determining what the content of the loot roll frame is (probably unnecessary?)
RLRFrame:RegisterEvent("ADDON_LOADED"); -- Fired when saved variables are loaded
RLRFrame:RegisterEvent("PLAYER_LOGOUT"); -- Fired when about to log out
RLRFrame:RegisterEvent("PARTY_LOOT_METHOD_CHANGED"); -- Fired when about to log out
RLRFrame:RegisterEvent("RAID_ROSTER_UPDATE"); --Fired when about to log out
RLRFrame:RegisterEvent("CHAT_MSG_ADDON"); -- 
RLRFrame:SetScript("OnEvent", RLRFrame.OnEvent); --probably sets script so that when an event fires, the function below is ran?

function RLRFrame:OnEvent(event,arg1,arg2,arg3,arg4) -- function pertaining to the frame that checks addon being loaded (probably very wrong to do it like this)
 			
	if event == "ADDON_LOADED" and arg1 == "RankedLootRoll" then  --checking that the addon being loaded is this one
			--message ("RLR main lua file v 0.0.5 loaded properly") --for some reason, message shows here, while print does not
			RegisterAddonMessagePrefix("RLR")
			RegisterAddonMessagePrefix("RLRReply")
			RegisterAddonMessagePrefix("RLRItemLink")
			RegisterAddonMessagePrefix("RLRRollAnnounce")
			
			print("Registered 4 prefixes")
			--ItemRollFrame:Hide()
			--print (event)
			--	if RLRSavedData == nil then -- for some reason, when I use print, it doesn´t show, but if I use message, it does
			--			print ("Setting RLRDataToSave to 0 since it is registering as nil")
			--			RLRSavedData = 0; -- setting it to 0 so that I can check if it saved after running it for the first time.
			--	else	 
			--		 -- TO BE IMPLEMENTED - print last entry from RLRSavedData
			--	end --end of if block checking RLRSavedData
		
		--elseif event == "CHAT_MSG_ADDON" then --and arg2 ~= "RLRReply" then
		--	print("RLR report: event= ",event,",arg1= ",arg1,",arg2=",arg2,",arg3=",arg3,",arg4=",arg4) --DEBUG
	end
		
	if event == "PARTY_LOOT_METHOD_CHANGED" then
			--print ("RLR DEBUG 43 - event fired", event)
			RLRFunctions.CheckLootMethod() 
	end	
	
	if event == "CHAT_MSG_ADDON" and arg1 == "RLRReply" then
		RLRFunctions.ReceiveReply(arg2)
	end	
		
	if event == "CHAT_MSG_ADDON" and arg1 == "RLRItemLink" then
		--print("Debugging CHAT_MSG_ADDON event handler in RankedLootRoll.lua: arg2=",arg2)
	--	print("RLR message: Anyone calling dibs on :",arg2,"?") -- DEBUG ONLY
		RLRFunctions.ShowFrame(arg2)
	end	
		
	if event == "CHAT_MSG_ADDON" and arg1 == "RLRRollAnnounce" then	 
		--print("RLRML DEBUG 35-received RLRRaidRollAnnounce, TODO is pass it to the history box")
		RLRFunctions.RollAnnounce(arg2)
	end


end


--end of function RLRFrame


RLRFrame:SetScript("OnEvent", RLRFrame.OnEvent); -- this is not doing what I want it to do (which is to register the slash command) but if I take it away, the message at line 10 doesn´t fire
function SlashCmdList.rlr(msg, modifier)
print("registering slash command /rlr ");
SLASH_RLR = "/rlr";
message("registering slash command /rlr ");
end

-- TABLES GET DEFINED BELOW HERE
RLRFunctions = {} -- making a table for storing functions
RLRFunctionsSave=RLRFunctions
local RLRFunctions = RLRFunctions -- because of the tip that local functions are accessed faster (I still don´t understand how exactly this works though)
RLRData = {}
RLRSavedData = {}
RLRSavedData2 = {} -- probably going to implement this, then I will replace all RLRSavedData references with RLRSavedData2 (and change RLRSavedData2 to RLRSavedData
RollEntry = {}
RLRChannels={}
RLRFrames={}
UISpecialFrames={}
RLRSessionLooted={}
RLRVersion=0014
-- TABLES GET DEFINED ABOVE HERE

	
-- FUNCTIONS GET DEFINED BELOW HERE

-- SLASH COMMAND FUNCTIONS

-- FUNCTIONS THAT DEAL WITH RLR COMM CHANNEL
function Strip(name) 
  return string.gsub(name, "%W", "")
end

CheckSum = function(text)
	local counter = 1
	local len = string.len(text)
	for i=1,len do
		counter = counter + string.byte(text, i)*math.pow(31, len- i)
	end
	counter = math.fmod(counter, 7919)
	return string.format("%06x", counter)
end

function RLRConcatRealmName(name,realm)
	--print("RLR DEBUG 109 RLRConcatRealmName realm =",realm)
	if realm~=nil then 
	name=strjoin ("-",name,realm)
	end
	return name
end

function RLRFunctions.CheckLootMethod() 
 -- TODO IN FUTURE - WHEN LOOT METHOD CHANGES, ASK WHETHER TO TURN ADDON ON. IF SO, SET SESSION VARIABLE WHICH OTHER EVENT CHECKS IN HANDLER WOULD CHECK BEFORE FIRING 
	local lootmethod=GetLootMethod()
			if not IsInGroup(Player) then --IF NOT IN GROUP, do nothing
			print ("not in group")
			end
			if lootmethod=="master" then --IF IN GROUP, JOIN THE RLR/RLRML COMM CHANNEL
			--print("RLR DEBUG 127 - Joining RLR/RLRML communication channel")
			RLRFunctions.Channel()
			end
end 

function RLRFunctions.CheckIfEligible(index)
	local Eligible=nil
	for ci = 1, GetNumGroupMembers() do -- let´s check how this behaves here - might have to include separate checks for raid/nonraid
				 if (GetMasterLootCandidate(index,ci) == UnitName("player")) then
						local Eligible=true
						return Eligible
				end
		return Eligible
	end
	return Eligible
end

function RLRFunctions.ShowFrame(message)
--print("RLR debug line 113 - showframe: message=",message)
	
local LootItemGUID,index,lootName,lootIcon,itemlink=strsplit(";",message)
		
	if _G[LootItemGUID.."Table"]==nil then
		_G[LootItemGUID.."Table"]={}
	end
	if 	_G[LootItemGUID.."Table"].lootIcon==nil then
		_G[LootItemGUID.."Table"].lootIcon=lootIcon
		_G[LootItemGUID.."Table"].itemlink=itemlink
		_G[LootItemGUID.."Table"].index=index
	end
		
local Eligible=RLRFunctions.CheckIfEligible(index)
	if Eligible==true then 
		local framenamejoined=strjoin(";","RLRLoot",LootItemGUID) --was index instead of GUID before
			if _G[framenamejoined]==nil then
			local FrameName = CreateFrame("frame",framenamejoined,UIParent,"RollFrame")
			_G[framenamejoined.."ItemName"]:SetText(itemlink)
			_G[framenamejoined.."IconOfLootItem"]:SetTexture(lootIcon)
		else 
		
		_G[framenamejoined]:Show() -- 
			print ("RLR DEBUG 149: already opened this - don´t create the frame again, just show it!") -- temporary 
			if _G[LootItemGUID..";RollFrame"]~=nil then
				_G[LootItemGUID..";RollFrame"]:Show()
			end

			end
	else
		print ("RLR DEBUG 168:",itemlink," dropped, but it seems you´re not eligible to roll for it. If you think that it´s an error, please poke Gonerill-Frostmane(EU).")
	end
end


function RLRFunctions.Debug(ButtonName)
do
	print ("-----------------------<DEBUG>------------------------------------")
	local prefix,LootItemGUID,ButtonName=strsplit(";",ButtonName)
	print ("RLR DEBUG 178  FrameName=",prefix..";"..LootItemGUID)
	print ("RLR DEBUG 179  _G[LootItemGUID..'Table'].lootIcon=",_G[LootItemGUID.."Table"].lootIcon)
	print ("RLR DEBUG 180  _G[LootItemGUID..'Table'].itemlink=",_G[LootItemGUID.."Table"].itemlink)
	print ("RLR DEBUG 181  _G[LootItemGUID..'Table'].index=",_G[LootItemGUID.."Table"].index)
	print ("-----------------------</DEBUG>------------------------------------")
	end
end

function RLRFunctions.HyperlinkClicked(ButtonName,button)
	do
	local framename,LootItemGUID=strsplit(";",ButtonName)
	if LootItemGUID=="RollFrame" then LootItemGUID,framename=strsplit(";",ButtonName) end
	local link=_G[LootItemGUID.."Table"].itemlink
	local text="text"
	SetItemRef(link, text, button);
   end
end

function RLRFunctions.RollAnnounce(message)
do
	local sender,roll,LootItemGUID,rollmin,rollmax,rolltype=strsplit(";",message)
	local sendername,senderrealm=strsplit("-",sender)
	local roll=tonumber(roll)
	
	print (" |cFFFF0000",sendername,"|r rolls |cFF00FF00", roll,"|r on |cFF0000FF lootitem:",index," |r in the range ",rollmin,", ",rollmax," (",rolltype," upgrade roll)")
--	print ("RLR DEBUG 156 roll, rolltype=",roll,rolltype)	

	if _G[LootItemGUID.."Table"]==nil then  -- LootItemGUID table doesn´t yet exist, create it
		_G[LootItemGUID.."Table"]={}
	end
	
	if _G[LootItemGUID..";RollFrame"]==nil then -- if the Roll recount frame doesn´t exist, create it
		local RollNumberParentName=strjoin("","RLRLoot;",LootItemGUID)
		local RollNumberFrame = CreateFrame("frame",LootItemGUID..";RollFrame",_G[RollNumberParentName],"RollNumberFrame") 
		_G[LootItemGUID..";RollFrameIconOfLootItem"]:SetTexture(_G[LootItemGUID.."Table"].lootIcon)
		_G[LootItemGUID..";RollFrameItemName"]:SetText(_G[LootItemGUID.."Table"].itemlink)
		RollNumberFrame:Show()
		RollNumberFrame:SetParent(nil)
	end
	
	if _G[LootItemGUID..";RollFrame"]:IsShown()==nil -- if Roll recount frame exists and is not shown, show it - possibly disable later?
		then  _G[LootItemGUID..";RollFrame"]:Show()
	end
		
	if _G[LootItemGUID.."Table"].Rolls==nil then -- if this is the first roll announced for this GUID
		_G[LootItemGUID.."Table"].Rolls={}
		_G[LootItemGUID.."Table"].HighestRoll=roll
		_G[LootItemGUID.."Table"].HighestSender=sendername
		_G[LootItemGUID.."Table"].HighestRollType=rolltype
		_G[LootItemGUID..";RollFrameRoll2"]:SetText(roll)
		_G[LootItemGUID..";RollFrameName"]:SetText(sendername)
		_G[LootItemGUID..";RollFrameIconOfLootItem"]:SetTexture(_G[LootItemGUID.."Table"].lootIcon)
		print("RLR DEBUG 227: _G[LootItemGUID..'Table'].itemlink=",_G[LootItemGUID.."Table"].itemlink)
		_G[LootItemGUID..";RollFrameItemName"]:SetText(_G[LootItemGUID.."Table"].itemlink)
		
	end
	
	if roll>_G[LootItemGUID.."Table"].HighestRoll then -- by now there should always be a HighestRoll set, so no need to worry about it being nil
		_G[LootItemGUID.."Table"].HighestRoll=roll
		_G[LootItemGUID.."Table"].HighestSender=sendername
		_G[LootItemGUID.."Table"].HighestRollType=rolltype
		_G[LootItemGUID..";RollFrameRoll2"]:SetText(roll)
		_G[LootItemGUID..";RollFrameName"]:SetText(sendername)
		-- need to update the highest roll part of the roll recount table 
	end
		
	tinsert (_G[LootItemGUID.."Table"].Rolls,roll)
	--print ("RLR DEBUG 207 - RollAnnounce complete")
	--local sendernametemp,rolltemp,rolltypetemp= unpack(LootItemGUID.sendername) -- DEBUG ONLY
	--print ("RLR DEBUG 165 sendertemp, rolltemp, rolltypetemp =",sendernametemp, rolltemp, rolltypetemp) -- DEBUG ONLY
end
end

 function RLRFunctions.GetMLName()
 local lootmethod, masterlooterPartyID, masterlooterRaidID = GetLootMethod()
		
		if UnitInParty("Player") == nil then
	--	print ("Not in a party, sending RLRML comm to self")
		RLRName=GetUnitName("Player")
		
		elseif lootmethod ~= "master" then
		print ("RLR DEBUG 158 not using master looter")
		RLRName=GetUnitName("Player")
		
		elseif masterlooterRaidID ~= nil then --I´m in a raid, everything seems to work as intended
		RLRName = GetRaidRosterInfo(masterlooterRaidID)
		print ("RLR DEBUG: GETMLName name= ",RLRName)

		elseif masterlooterRaidID == nil and masterlooterPartyID == 0 and lootmethod == "master" then -- I´m not in a raid and ML is probably myself
		RLRName = GetUnitName("Player")
	--	print ("RLR DEBUG: GETMLName name= ",RLRName)
		
		elseif masterlooterRaidID == nil and masterlooterPartyID ~= 0 and lootmethod == "master" then -- I´m not in a raid, I AM in a party with the masterlooter and ML is probably not myself?
		local temp = strjoin ("","Party",masterlooterPartyID)
		print ("RLR DEBUG 170: GETMLName name= ",temp)
		RLRName,RLRrealm = GetUnitName(temp,true)
		print("RLR DEBUG 189, RLRName,RLRRealm=",RLRName,RLRrealm)
		RLRName=RLRConcatRealmName(RLRName,RLRrealm)
	-- still not showing realm name though
	-- print ("RLR DEBUG: GETMLName name=",RLRname)
		
	end
	--print ("RLRFunctions.GetMLName from RankedLootRoll.lua - RLRName=",RLRName)
	return RLRName
	end
	 
 function RLRFunctions.Channel() -- Takes care of creating/joining channel for communication between RLRML and RLR
	--print ("RLR DEBUG 239 RLRFunctions.Channel")
	do
	RLRName=RLRFunctions.GetMLName()
	if RLRName then
	local cname=RLRName	
	local cs = CheckSum(cname) -- cleaning the loot master name and adding checksum to create unique channel name
	local cname = Strip(cname)
	local cname = string.sub(cname, 1, 8)
	local GroupChannelName = ("RLR" .. cname .. cs)
--	print ("RLR and RLRML communication channel is called", GroupChannelName)
	SendAddonMessage("RLR",GroupChannelName,"RAID" );
	--SendChatMessage(GroupChannelName, "GUILD", nil) --debug, just checking if it works, remove later
	print("RLR channel name=",GroupChannelName)
--  print("whisper target name=",RLRName)
	-- now join the channel if I´m not already in it
	
	--if tContains(GetChannelList(),GroupChannelName)==nil then
	--if GetChannelName(GroupChannelName) == nil then
	
	for index,value in ipairs(RLRChannels) do 
		if value~=GroupChannelName then
			LeaveChannelByName(value)
		print ("Leaving",value)
		end
	end
	wipe(RLRChannels)
	print ("joining channel ",GroupChannelName)
	
	JoinChannelByName(GroupChannelName)
	tinsert(RLRChannels, GroupChannelName)
	--else -- else tell me I´m already in
	--print ("already in the channel")
	--tinsert(RLRChannels, GroupChannelName)
	end
	end
	end

 
function RLRFunctions.ReceiveReply(Reply)
do
local roll,LootItemGUID,rollmin,rollmax,rolltype=strsplit(";",Reply)

	if _G[LootItemGUID.."Table"]==nil then
		_G[LootItemGUID.."Table"]={}
	end
	
	if _G[LootItemGUID..";RollFrame"]==nil then
		local RollNumberParentName=strjoin("","RLRLoot;",LootItemGUID)
		print("RLR DEBUG 297: Parent frame for roll recount frame is ",RollNumberParentName)
		local RollNumberFrame = CreateFrame("frame",LootItemGUID..";RollFrame",_G[RollNumberParentName],"RollNumberFrame") -- replaced ButtonName by LootItemGUID as second arg on 31/08, still have 3rd arg to go
		RollNumberFrame:SetParent(nil)
		_G[RollNumberFrame.."IconOfLootItem"]:SetTexture(_G[LootItemGUID.."Table"].lootIcon)
		_G[RollNumberFrame.."ItemName"]:SetText(_G[LootItemGUID.."Table"].itemlink)
		RollNumberFrame:Show()
		print ("RLR DEBUG 292 - itemlink for roll recount frame =",_G[LootItemGUID.."Table"].itemlink)
		--_G[RollNumberParentName]:GetParent():Hide()
	end
	
	if _G[LootItemGUID..";RollFrame"]~=nil then
	print ("RLR DEBUG 347 - Rollnumber frame already exists, not creating/showing it again")
	end
	
	local ReplyString=strjoin("","You roll |cFF00FF00", roll,"|r on |cFF0000FF lootitem:",LootItemGUID," |r in the range ",rollmin,", ",rollmax," (",rolltype," upgrade roll)")
	print("|cFF00FF00",ReplyString)
	_G[LootItemGUID..";RollFrameRoll1"]:SetText(roll)
	_G[LootItemGUID.."Table"].MyRoll=roll
	end
end

function RLRFunctions.OptionsPanel(...) -- RLR Options panel
   message('loading rlr options');
end

function RLRFunctions.History(...) -- RLR History panel
   print ("Last record from the previous session: " .. RLRDataToSave .. "");
   SendAddonMessage("RLR",GroupChannelName, "RAID" );
end


function RLRFunctions.Test(msg,par1,par2,par3)
print("DEBUG: no function in RLR is currently assigned for testing ")
end

function RLRFunctions.Roll(rolltype,LootItemGUID) -- is called by clicking a button on the lootframe
--  print('RLR DEBUG: performing a major upgrade roll')
--	print ("RLR DEBUG 217: LootMessage=",rolltype,LootItemGUID)
	local RLRName=RLRFunctions.GetMLName()
	local message=strjoin(";",rolltype,LootItemGUID)
	SendAddonMessage("RLRRoll",message,"WHISPER",RLRName)
  end
  
    
function RLRFunctions.SavedData(...) -- RLR printing the contents of the table "RLRFunctions"
  print ("printing the contents of the table RLRSavedData");
  table.foreach(RLRSavedData, print) -- Prints the whole table, going to remove this soon
 print ("");
 print ("Now printing the last entry once more, for good measure");
  local RLRTableLength = table.getn(RLRSavedData2); -- find the size of the table 
  local printlastentry = tostring (RLRSavedData2,RLRTableLength)
  print(printlastentry); -- prints the last entry from the table, but it needs to be converted to string first
  end
-- FUNCTIONS ARE DEFINED ABOVE HERE
	


	
--WORK IN PROGRESS - SLASH COMMAND
SLASH_RLR1, SLASH_RLR2 = '/rlr', '/RLR'; 
function SlashCmdList.RLR(msgfull, editbox)--, editbox)
local msg,par1,par2,par3=strsplit(" ",msgfull)
local msg=strlower(msg)
 if msg == 'history' then
RLRFunctions.History();
 elseif msg == 'roll' then
RLRFunctions.Roll();
elseif msg == 'test' then
RLRFunctions.Test(msg,arg1,arg2,arg3)
elseif msg == 'saveddata' then
RLRFunctions.SavedData();
elseif msg == "showframe" then
RLRFunctions.ShowFrame()
elseif string.find(msg, "tableinsert") ~=  nil then -- if argument contains tableinsert, I want to insert the second argument
--ar1, ar2, ar3 =(string.split(" ",msg,3)); -- apparently this can parse the msg into individual words separated by space if I use print, but not to set arguments
local RLRArgument = {strsplit(" ",msg,3)}
   print(msg)
   RLRFunctions.TableInsert(ar1,ar2,ar3); -- not working at the moment, ar1, ar2 and ar3 are nil
 else
 print("Raid Loot Roll has the following arguments");
  print("/rlr history for records history");
 print("/rlr major to perform a major upgrade roll");
 print("/rlr tableinsert [modifier] to test inserting stuff into table RLRSavedData");
 print("/rlr saveddata to test inserting stuff into table RLRSavedData");
 end
end
--WORK IN PROGRESS - SLASH COMMAND

function RLRFunctions.RollButtonClick(ButtonName)
	do
	local framename,LootItemGUID,rolltype=strsplit(";",ButtonName)
		print ("RLR DEBUG 422: index=",_G[LootItemGUID.."Table"].index)
		-- print ("rolltype=",rolltype)
		RLRFunctions.Roll(rolltype,LootItemGUID)
		
		if _G[LootItemGUID..";RollFrame"]==nil then
				local RollNumberFrame = CreateFrame("frame",LootItemGUID..";RollFrame",_G[ButtonName]:GetParent(),"RollNumberFrame") -- replaced ButtonName by LootItemGUID
				--print ("RLR DEBUG 390, _G[LootItemGUID..Table].itemlink=",_G[LootItemGUID.."Table"].itemlink)
				RollNumberFrame:Show()
				
				_G[LootItemGUID..";RollFrameIconOfLootItem"]:SetTexture(_G[LootItemGUID.."Table"].lootIcon)
				_G[LootItemGUID..";RollFrameItemName"]:SetText(_G[LootItemGUID.."Table"].itemlink)
				RollNumberFrame:Show()
				
				
				
				
				_G[LootItemGUID..";RollFrameIconOfLootItem"]:SetTexture(_G[LootItemGUID.."Table"].lootIcon)
				_G[LootItemGUID..";RollFrameItemName"]:SetText(_G[LootItemGUID.."Table"].itemlink)
				RollNumberFrame:SetParent(nil)
		end
		
		if _G[LootItemGUID..";RollFrame"]~=nil and _G[LootItemGUID..";RollFrame"]:IsShown()==nil then 
						_G[LootItemGUID..";RollFrame"]:Show()
				end
		
	_G[ButtonName]:GetParent():Hide()
	end
end


	-- NEW STUFF COPIED OVER FROM WOWWIKI, FOR SETTING THE FAUXSCROLLFRAME
	

function RLR_OnLoad()
  for i=1,50 do
    RLRData[i] = "Test "..math.random(100)
  end
  RLRScrollBar:Show()
end

function RLRScrollBar_Update()
  local line; -- 1 through 5 of our window to scroll
  local lineplusoffset; -- an index into our data calculated from the scroll offset
  FauxScrollFrame_Update(RLRScrollBar,50,5,16);
  for line=1,5 do
    lineplusoffset = line + FauxScrollFrame_GetOffset(RLRScrollBar);
    if lineplusoffset <= 50 then
      getglobal("RLREntry"..line):SetText(RLRData[lineplusoffset]);
      getglobal("RLREntry"..line):Show();
    else
      getglobal("RLREntry"..line):Hide();
    end
  end
end
	